deactivatepackage(ndNoChainKillsPackage);
package ndNoChainKillsPackage
{
	function SimSet::ndTickUndo(%this, %count, %client)//Modify the duplicator to not cause chain kills on undo.
	{
		//Sadly I have to completely overwrite the duplicator's undo function.  Hopefully this never fucks up on an update.
		if(%count > %this.getCount())
			%start = %this.getCount();
		else
			%start = %count;

		if(%start > $Pref::Server::ND::ProcessPerTick)
			%end = %start - $Pref::Server::ND::ProcessPerTick;
		else
			%end = 0;

		for(%i = %start - 1; %i >= %end; %i--)
		{
			%brick = %this.getObject(%i);
			if (getTrustLevel (%brick, %client) < $TrustLevel::UndoBrick)//If brick ownership changes before we undo, we should check our permissions.
			{
				%client.sendTrustFailureMessage (%brick.getGroup ());
				continue;
			}

			if(isObject(%brick.hBot))
				%brick.hBot.schedule(1,"delete");

			if(%start <= 1024)//New Dup is set up to animate if start <= 1024.  So let's do that.
			{
				if(%brick.willCauseChainKill())
				{
					%deadBrick = new FxDTSBrick()
					{
						datablock = %brick.getDatablock();
						position = %brick.position;
						isPlanted = 1;
					};
					%deadBrick.setTransform(%brick.getTransform());
					%deadBrick.setColor(%brick.colorID);
					%deadBrick.setPrint(%brick.printID);
					%deadBrick.setShapeFx(%brick.shapeFxID);
					%deadBrick.killBrick();

					%brick.delete();
				}
				else
				{
					%brick.killBrick();
				}
			}
			else
			{
				%brick.delete();
			}
		}

		//If undo is taking long, tell the client how far we get
		if(%client.ndLastMessageTime + 0.1 < $Sim::Time)
		{
			%client.ndLastMessageTime = $Sim::Time;

			%percent = mFloor(100 - (%end * 100 / %this.brickCount));
			commandToClient(%client, 'centerPrint', "<font:Verdana:20>\c6Undo in progress...\n<font:Verdana:17>\c3" @ %percent @ "%\c6 finished.", 10);
		}

		if(%end <= 0)
		{
			%this.delete();
			%client.ndUndoInProgress = false;

			if(%start != 0)
				commandToClient(%client, 'centerPrint', "<font:Verdana:20>\c6Undo finished.", 2);

			return;
		}

		%this.schedule(30, ndTickUndo, %end, %client);
	}
};
activatepackage(ndNoChainKillsPackage);