
//We want to modify a duplicator function if the duplicator is enabled.  So check for that.
if(isFunction("SimSet","ndTickUndo"))//Has the New Dup already executed?
{
	exec("./ndNoChainKills.cs");
}
else
{
	if($GameModeArg $= "")//Custom gamemode
	{
		//search for $Addon enabled variable.
		if($AddOn__Tool_NewDuplicator)
		{
			exec("./ndNoChainKills.cs");
		}
	}
	else//Actual gamemode of some sort.
	{
		//Search $GameMode::AddOn variables.
		for($noChainKillsTemp=0;$noChainKillsTemp<$GameMode::AddOnCount;$noChainKillsTemp++) //I forget if I can use local variables here, so... long ass global it is.
		{
			if($GameMode::AddOn[$noChainKillsTemp] $= "Tool_NewDuplicator")
			{
				exec("./ndNoChainKills.cs");
			}
		}
		$noChainKillsTemp = "";
	}
}

deactivatepackage(noChainKillsPackage);
package noChainKillsPackage
{
	function hammerImage::onHitObject (%this, %player, %slot, %hitObj, %hitPos, %hitNormal)//Modify the hammer to not kill chains.
	{
		%client = %player.client;
		if (!isObject (%client))
		{
			return;
		}
		if (%hitObj.getType () & $TypeMasks::FxBrickAlwaysObjectType)
		{
			if (%hitObj.willCauseChainKill ())
			{
				ServerPlay3D (hammerHitSound, %hitPos);
				if (getTrustLevel (%player, %hitObj) < $TrustLevel::Hammer)
				{
					if (%hitObj.stackBL_ID $= "" || %hitObj.stackBL_ID != %client.getBLID ())
					{
						%client.sendTrustFailureMessage (%hitObj.getGroup ());
						return;
					}
				}
				%hitObj.onToolBreak (%client);
				$CurrBrickKiller = %client;

				//Can't use kill brick here. So we delete it, and make a new brick to kill for the animation.
				//I tried setting the connected bricks to .isBaseplate = true, but that didnt help; The .isBaseplate() function still returns 0 after setting the value. (That field must be set before running .plant() to be effective, i think.)
				%deadBrick = new FxDTSBrick()
				{
					datablock = %hitObj.getDatablock();
					position = %hitObj.position;
					isPlanted = 1;
				};
				%deadBrick.setTransform(%hitObj.getTransform());
				%deadBrick.setColor(%hitObj.colorID);
				%deadBrick.setPrint(%hitObj.printID);
				%deadBrick.setShapeFx(%hitObj.shapeFxID);
				%deadBrick.killBrick();

				if(isObject(%hitObj.hBot))
					%hitObj.hBot.schedule(1,"delete");

				%hitObj.delete();
				return;
			}
		}
		Parent::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal);
		return;
	}
	function serverCmdUndoBrick(%client)//Modify Ctrl + Z to not cause chain kills.
	{
		%stack = %client.undoStack;
		if(%stack.head <= 0)
			%position = %stack.size-1;
		else
			%position = %stack.head-1;

		%value = %stack.val[%position];//I could just use %val = queue.pop(); queue.push(%val).  But where's the fun in that.
		if(getField(%value,1)$="PLANT")
		{
			if(!isObject(%brick = getField(%value,0)))
			{
				Parent::serverCmdUndoBrick(%client);
				return;
			}
			if(%brick.willCauseChainKill())
			{
				//Normally the game will run undoTrustCheck here, which starts a chain kill on all trusted bricks in the stack.
				//We uh- we don't want that.
				//But it does make me realize... because tools exist that change ownership of a brick.  I need to do a trust check here...
				//Doesn't help that the default function doesn't do this, but... I guess that additional trust check should be packaged with the add-ons that change brick ownership.
				if (getTrustLevel (%brick, %client) < $TrustLevel::UndoBrick)
				{
					%client.sendTrustFailureMessage (%brick.getGroup ());
					%stack.pop();
					return;
				}


				%deadBrick = new FxDTSBrick()
				{
					datablock = %brick.getDatablock();
					position = %brick.position;
					isPlanted = 1;
				};
				%deadBrick.setTransform(%brick.getTransform());
				%deadBrick.setColor(%brick.colorID);
				%deadBrick.setPrint(%brick.printID);
				%deadBrick.setShapeFx(%brick.shapeFxID);
				%deadBrick.killBrick();

				if(isObject(%brick.hBot))
					%brick.hBot.schedule(1,"delete");

				%brick.delete();
				%stack.pop();
				return;
			}
		}
		Parent::serverCmdUndoBrick(%client);
	}
};
activatepackage(noChainKillsPackage);